package com.jpsoft.shinestar.modules.base.controller;

import com.github.pagehelper.Page;
import com.jpsoft.shinestar.modules.base.entity.ParkingApply;
import com.jpsoft.shinestar.modules.base.service.ParkingApplyService;
import com.jpsoft.shinestar.modules.common.dto.MessageResult;
import com.jpsoft.shinestar.modules.common.dto.Sort;
import com.jpsoft.shinestar.modules.common.utils.PojoUtils;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.*;

@RestController
@RequestMapping("/base/parkingApply")
public class ParkingApplyController {
    private Logger logger = LoggerFactory.getLogger(getClass());

    @Autowired
    private ParkingApplyService parkingApplyService;

    @ApiOperation(value="创建空记录")
    @GetMapping("create")
    public MessageResult<ParkingApply> create(){
        MessageResult<ParkingApply> msgResult = new MessageResult<>();

        ParkingApply parkingApply = new ParkingApply();

        msgResult.setData(parkingApply);
        msgResult.setResult(true);

        return msgResult;
    }
    
    @ApiOperation(value="添加信息")
    @PostMapping("add")
    public MessageResult<ParkingApply> add(@RequestBody ParkingApply parkingApply,@RequestAttribute String subject){
        MessageResult<ParkingApply> msgResult = new MessageResult<>();

        try {
            parkingApply.setId(UUID.randomUUID().toString());
            parkingApply.setDelFlag(false);
            parkingApply.setCreateBy(subject);
            parkingApply.setCreateTime(new Date());
            
            int affectCount = parkingApplyService.insert(parkingApply);

            if (affectCount > 0) {
                msgResult.setResult(true);
                msgResult.setData(parkingApply);
            } else {
                msgResult.setResult(false);
                msgResult.setMessage("数据库添加失败");
            }
        }
        catch(Exception ex){
            logger.error(ex.getMessage(),ex);

            msgResult.setResult(false);
            msgResult.setMessage(ex.getMessage());
        }

        return msgResult;
    }

    @ApiOperation(value="获取信息")
    @GetMapping("edit/{id}")
    public MessageResult<ParkingApply> edit(@PathVariable("id") String id){
        MessageResult<ParkingApply> msgResult = new MessageResult<>();

        try {
            ParkingApply parkingApply = parkingApplyService.get(id);

            if (parkingApply != null) {
                msgResult.setResult(true);
                msgResult.setData(parkingApply);
            } else {
                msgResult.setResult(false);
                msgResult.setMessage("数据库不存在该记录!");
            }
        }
        catch(Exception ex){
            logger.error(ex.getMessage(),ex);

            msgResult.setResult(false);
            msgResult.setMessage(ex.getMessage());
        }

        return msgResult;
    }

    @ApiOperation(value="更新用户")
    @PostMapping("update")
    public MessageResult<ParkingApply> update(@RequestBody ParkingApply parkingApply,@RequestAttribute String subject){
        MessageResult<ParkingApply> msgResult = new MessageResult<>();

        try {
            parkingApply.setUpdateBy(subject);
            parkingApply.setUpdateTime(new Date());
            
            int affectCount = parkingApplyService.update(parkingApply);

            if (affectCount > 0) {
                msgResult.setResult(true);
                msgResult.setData(parkingApply);
            } else {
                msgResult.setResult(false);
                msgResult.setMessage("数据库更新失败");
            }
        }
        catch(Exception ex){
            logger.error(ex.getMessage(),ex);

            msgResult.setResult(false);
            msgResult.setMessage(ex.getMessage());
        }

        return msgResult;
    }

	@ApiOperation(value="删除")
    @PostMapping("delete/{id}")
    public MessageResult<Integer> delete(@PathVariable("id") String id,@RequestAttribute String subject){
        MessageResult<Integer> msgResult = new MessageResult<>();

        try {
            ParkingApply parkingApply = parkingApplyService.get(id);
            parkingApply.setDelFlag(true);
            parkingApply.setUpdateBy(subject);
            parkingApply.setUpdateTime(new Date());

            int affectCount = parkingApplyService.update(parkingApply);

            if (affectCount > 0) {
                msgResult.setResult(true);
                msgResult.setData(affectCount);
            } else {
                msgResult.setResult(false);
                msgResult.setMessage("删除失败");
            }
        }
        catch(Exception ex){
            logger.error(ex.getMessage(),ex);

            msgResult.setResult(false);
            msgResult.setMessage(ex.getMessage());
        }

        return msgResult;
    }


    @ApiOperation(value="批量删除")
    @PostMapping("batchDelete")
    public MessageResult<Integer> batchDelete(@RequestBody List<String> idList,@RequestAttribute String subject){
        MessageResult<Integer> msgResult = new MessageResult<>();

        try {
            int affectCount = 0;

            for (String id : idList) {
                ParkingApply parkingApply = parkingApplyService.get(id);
                parkingApply.setDelFlag(true);
                parkingApply.setUpdateBy(subject);
                parkingApply.setUpdateTime(new Date());

                affectCount += parkingApplyService.update(parkingApply);
            }

            if (affectCount > 0) {
                msgResult.setResult(true);
                msgResult.setData(affectCount);
            } else {
                msgResult.setResult(false);
                msgResult.setMessage("删除失败");
            }
        }
        catch(Exception ex){
            logger.error(ex.getMessage(),ex);

            msgResult.setResult(false);
            msgResult.setMessage(ex.getMessage());
        }

        return msgResult;
    }

    @ApiOperation(value="列表")
    @RequestMapping(value = "pageList",method = RequestMethod.POST)
    public MessageResult<Map> pageList(
            String id,
            @RequestParam(value="pageIndex",defaultValue="1") int pageIndex,
            @RequestParam(value="pageSize",defaultValue="20") int pageSize,
            @RequestAttribute String subject){

        //当前用户ID
        System.out.println(subject);

        MessageResult<Map> msgResult = new MessageResult<>();

        Map<String,Object> searchParams = new HashMap<>();

        List<Sort> sortList = new ArrayList<>();
        sortList.add(new Sort("id_","asc"));

        if (StringUtils.isNotEmpty(id)) {
            searchParams.put("id", "%" + id + "%");
        }
        Page<ParkingApply> page = parkingApplyService.pageSearch(searchParams,pageIndex,pageSize,sortList);

        msgResult.setResult(true);
        msgResult.setData(PojoUtils.pageWrapper(page));

        return msgResult;
    }
}
